package org.blender.dna;

import java.io.IOException;
import org.cakelab.blender.io.block.Block;
import org.cakelab.blender.io.block.BlockTable;
import org.cakelab.blender.nio.CArrayFacade;
import org.cakelab.blender.nio.CFacade;
import org.cakelab.blender.nio.CMetaData;
import org.cakelab.blender.nio.CPointer;


/**
 * Generated facet for DNA struct type 'GPUFXSettings'.
 * 
 * <h3>Class Documentation</h3>
 * 
 */

@CMetaData(size32=16, size64=24)
public class GPUFXSettings extends CFacade {

	/**
	 * This is the sdna index of the struct GPUFXSettings.
	 * <p>
	 * It is required when allocating a new block to store data for GPUFXSettings.
	 * </p>
	 * @see {@link org.cakelab.blender.io.dna.internal.StructDNA}
	 * @see {@link org.cakelab.blender.io.block.BlockTable#allocate}
	 */
	public static final int __DNA__SDNA_INDEX = 23;

	/**
	 * Field descriptor (offset) for struct member 'dof'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * GPUFXSettings gpufxsettings = ...;
	 * CPointer&lt;Object&gt; p = gpufxsettings.__dna__addressof(GPUFXSettings.__DNA__FIELD__dof);
	 * CPointer&lt;CPointer&lt;GPUDOFSettings&gt;&gt; p_dof = p.cast(new Class[]{CPointer.class, GPUDOFSettings.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'dof'</li>
	 * <li>Signature: 'GPUDOFSettings*'</li>
	 * <li>Actual Size (32bit/64bit): 4/8</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__dof = new long[]{0, 0};

	/**
	 * Field descriptor (offset) for struct member 'ssao'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * GPUFXSettings gpufxsettings = ...;
	 * CPointer&lt;Object&gt; p = gpufxsettings.__dna__addressof(GPUFXSettings.__DNA__FIELD__ssao);
	 * CPointer&lt;CPointer&lt;GPUSSAOSettings&gt;&gt; p_ssao = p.cast(new Class[]{CPointer.class, GPUSSAOSettings.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'ssao'</li>
	 * <li>Signature: 'GPUSSAOSettings*'</li>
	 * <li>Actual Size (32bit/64bit): 4/8</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__ssao = new long[]{4, 8};

	/**
	 * Field descriptor (offset) for struct member 'fx_flag'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * GPUFXSettings gpufxsettings = ...;
	 * CPointer&lt;Object&gt; p = gpufxsettings.__dna__addressof(GPUFXSettings.__DNA__FIELD__fx_flag);
	 * CPointer&lt;Byte&gt; p_fx_flag = p.cast(new Class[]{Byte.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'fx_flag'</li>
	 * <li>Signature: 'char'</li>
	 * <li>Actual Size (32bit/64bit): 1/1</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__fx_flag = new long[]{8, 16};

	/**
	 * Field descriptor (offset) for struct member 'pad'.
	 * <h3>Pointer Arithmetics</h3>
	 * <p>
	 * This is how you get a reference on the corresponding field in the struct:
	 * </p>
	 * <pre>
	 * GPUFXSettings gpufxsettings = ...;
	 * CPointer&lt;Object&gt; p = gpufxsettings.__dna__addressof(GPUFXSettings.__DNA__FIELD__pad);
	 * CPointer&lt;CArrayFacade&lt;Byte&gt;&gt; p_pad = p.cast(new Class[]{CArrayFacade.class, Byte.class});
	 * </pre>
	 * <h3>Metadata</h3>
	 * <ul>
	 * <li>Field: 'pad'</li>
	 * <li>Signature: 'char[7]'</li>
	 * <li>Actual Size (32bit/64bit): 7/7</li>
	 * </ul>
	 */
	public static final long[] __DNA__FIELD__pad = new long[]{9, 17};

	public GPUFXSettings(long __address, Block __block, BlockTable __blockTable) {
		super(__address, __block, __blockTable);
	}

	protected GPUFXSettings(GPUFXSettings that) {
		super(that.__io__address, that.__io__block, that.__io__blockTable);
	}

	/**
	 * Get method for struct member 'dof'.
	 * @see #__DNA__FIELD__dof
	 */
	
	public CPointer<GPUDOFSettings> getDof() throws IOException
	{
		long __dna__targetAddress;
		if ((__io__pointersize == 8)) {
			__dna__targetAddress = __io__block.readLong(__io__address + 0);
		} else {
			__dna__targetAddress = __io__block.readLong(__io__address + 0);
		}
		Class<?>[] __dna__targetTypes = new Class[]{GPUDOFSettings.class};
		return new CPointer<GPUDOFSettings>(__dna__targetAddress, __dna__targetTypes, __io__blockTable.getBlock(__dna__targetAddress, GPUDOFSettings.__DNA__SDNA_INDEX), __io__blockTable);
	}

	/**
	 * Set method for struct member 'dof'.
	 * @see #__DNA__FIELD__dof
	 */
	
	public void setDof(CPointer<GPUDOFSettings> dof) throws IOException
	{
		long __address = ((dof == null) ? 0 : dof.getAddress());
		if ((__io__pointersize == 8)) {
			__io__block.writeLong(__io__address + 0, __address);
		} else {
			__io__block.writeLong(__io__address + 0, __address);
		}
	}

	/**
	 * Get method for struct member 'ssao'.
	 * @see #__DNA__FIELD__ssao
	 */
	
	public CPointer<GPUSSAOSettings> getSsao() throws IOException
	{
		long __dna__targetAddress;
		if ((__io__pointersize == 8)) {
			__dna__targetAddress = __io__block.readLong(__io__address + 8);
		} else {
			__dna__targetAddress = __io__block.readLong(__io__address + 4);
		}
		Class<?>[] __dna__targetTypes = new Class[]{GPUSSAOSettings.class};
		return new CPointer<GPUSSAOSettings>(__dna__targetAddress, __dna__targetTypes, __io__blockTable.getBlock(__dna__targetAddress, GPUSSAOSettings.__DNA__SDNA_INDEX), __io__blockTable);
	}

	/**
	 * Set method for struct member 'ssao'.
	 * @see #__DNA__FIELD__ssao
	 */
	
	public void setSsao(CPointer<GPUSSAOSettings> ssao) throws IOException
	{
		long __address = ((ssao == null) ? 0 : ssao.getAddress());
		if ((__io__pointersize == 8)) {
			__io__block.writeLong(__io__address + 8, __address);
		} else {
			__io__block.writeLong(__io__address + 4, __address);
		}
	}

	/**
	 * Get method for struct member 'fx_flag'.
	 * @see #__DNA__FIELD__fx_flag
	 */
	
	public byte getFx_flag() throws IOException
	{
		if ((__io__pointersize == 8)) {
			return __io__block.readByte(__io__address + 16);
		} else {
			return __io__block.readByte(__io__address + 8);
		}
	}

	/**
	 * Set method for struct member 'fx_flag'.
	 * @see #__DNA__FIELD__fx_flag
	 */
	
	public void setFx_flag(byte fx_flag) throws IOException
	{
		if ((__io__pointersize == 8)) {
			__io__block.writeByte(__io__address + 16, fx_flag);
		} else {
			__io__block.writeByte(__io__address + 8, fx_flag);
		}
	}

	/**
	 * Get method for struct member 'pad'.
	 * @see #__DNA__FIELD__pad
	 */
	
	public CArrayFacade<Byte> getPad() throws IOException
	{
		Class<?>[] __dna__targetTypes = new Class[]{Byte.class};
		int[] __dna__dimensions = new int[]{
			7
		};
		if ((__io__pointersize == 8)) {
			return new CArrayFacade<Byte>(__io__address + 17, __dna__targetTypes, __dna__dimensions, __io__block, __io__blockTable);
		} else {
			return new CArrayFacade<Byte>(__io__address + 9, __dna__targetTypes, __dna__dimensions, __io__block, __io__blockTable);
		}
	}

	/**
	 * Set method for struct member 'pad'.
	 * @see #__DNA__FIELD__pad
	 */
	
	public void setPad(CArrayFacade<Byte> pad) throws IOException
	{
		long __dna__offset;
		if ((__io__pointersize == 8)) {
			__dna__offset = 17;
		} else {
			__dna__offset = 9;
		}
		if (__io__equals(pad, __io__address + __dna__offset)) {
			return;
		} else if (__io__same__encoding(this, pad)) {
			__io__native__copy(__io__block, __io__address + __dna__offset, pad);
		} else {
			__io__generic__copy( getPad(), pad);
		}
	}

	/**
	 * Instantiates a pointer on this instance.
	 */
	public CPointer<GPUFXSettings> __io__addressof() {
		return new CPointer<GPUFXSettings>(__io__address, new Class[]{GPUFXSettings.class}, __io__block, __io__blockTable);
	}

}
